//////////////////////////////
// Mouse Functions
//////////////////////////////

//draw a vertical or horizontal line to the screen_map
function draw_box_line(&vec1,&vec2,pixel) {		
	var p[3];
	var m[3];
	var d;
	vec_set(p,vec1);
	m.x = sign(vec2[0] - vec1[0]);
	m.y = sign(vec2[1] - vec1[1]);
	d = vec_dist(vec1,vec2);
	while(d >= 0) {
		pixel_to_bmap(screen_map,p.x,p.y,pixel);
		p.x += m.x;
		p.y += m.y;		
		d -= 1;
		}	
	}

//setup and start the mouse pointer
function init_mouse() {
	mouse_map = arrow;
	while(1) {
		MOUSE_POS.X = POINTER.X;
   	MOUSE_POS.Y = POINTER.Y;
   	
   	if(mouse_left) {
   		dest_set = 0;
   		if(!left_pressed) {
   			vec_set(mousebox1,mouse_pos);
   			vec_set(mousebox2,mouse_pos);
   			} 
   		temp_format = bmap_lock(screen_map,0);
			temp_pixel = pixel_for_vec(vector(0,0,0),0,temp_format);
			vec_Set(pt1,vector(mousebox1.x,mousebox1.y,0));	
   		vec_Set(pt2,vector(mousebox1.x,mousebox2.y,0));
   		vec_Set(pt3,vector(mousebox2.x,mousebox1.y,0));
   		vec_Set(pt4,vector(mousebox2.x,mousebox2.y,0));
			draw_box_line(pt1,pt2,temp_pixel);		
			draw_box_line(pt1,pt3,temp_pixel);
			draw_box_line(pt4,pt2,temp_pixel);
			draw_box_line(pt4,pt3,temp_pixel);
			vec_set(mousebox2,mouse_pos);
			temp_pixel = pixel_for_vec(vector(255,255,255),100,temp_format);
			vec_Set(pt1,vector(mousebox1.x,mousebox1.y,0));	
   		vec_Set(pt2,vector(mousebox1.x,mousebox2.y,0));
   		vec_Set(pt3,vector(mousebox2.x,mousebox1.y,0));
   		vec_Set(pt4,vector(mousebox2.x,mousebox2.y,0));   		
			draw_box_line(pt1,pt2,temp_pixel);		
			draw_box_line(pt1,pt3,temp_pixel);
			draw_box_line(pt4,pt2,temp_pixel);
			draw_box_line(pt4,pt3,temp_pixel);   			
			bmap_unlock(screen_map);
//  		screen_pan.visible = on;
   		left_pressed = 1;
			}	  	
   	if(!mouse_left) {
   		if(left_pressed) {
   			temp_format = bmap_lock(screen_map,0);
				temp_pixel = pixel_for_vec(vector(0,0,0),0,temp_format);
				vec_Set(pt1,vector(mousebox1.x,mousebox1.y,0));	
	   		vec_Set(pt2,vector(mousebox1.x,mousebox2.y,0));
	   		vec_Set(pt3,vector(mousebox2.x,mousebox1.y,0));
	   		vec_Set(pt4,vector(mousebox2.x,mousebox2.y,0));
				draw_box_line(pt1,pt2,temp_pixel);		
				draw_box_line(pt1,pt3,temp_pixel);
				draw_box_line(pt4,pt2,temp_pixel);
				draw_box_line(pt4,pt3,temp_pixel);
				bmap_unlock(screen_map);	
	//			screen_pan.visible = off;
				you = null;
   		//	pt1.z = 2000;
   		//	pt4.z = 2000;
			//	vec_for_screen(pt1,camera);	
			//	vec_for_screen(pt4,camera);			
			//	trace_mode = ignore_sprites;
   		//	trace(camera.x,pt1);
			//	vec_Set(pt1,target);
			//	trace(camera.x,pt4);
			//	vec_Set(pt4,target);
				
				you = ent_next(null);
				temp_var = 0;
				while(you != null) {
					vec_set(Temp,you.x);
					vec_to_screen(temp,camera);
					if(temp.x >= min(pt1.x,pt4.x) && temp.x <= max(pt1.x,pt4.x) && temp.y >= min(pt1.y,pt4.y) && temp.y <= max(pt1.y,pt4.y) && you.team != 0) {
						you.selected = on;
						if(temp_var == 0 && you.selected == on) { play_random_snd_fx();	}
						temp_var = 1;		//indicate an entity was found
						}				
					you = ent_next(you);
					}
				if(temp_var == 0) {		//no entity found, use normal click method
					you = null;
					vec_Set(temp,mouse_pos);
					temp.z = 2000;
					vec_for_screen(temp,camera);			
					trace_mode = ignore_sprites;
   				trace(camera.x,temp);
					if(you != null) {
						if(you.team != 0) {you.selected = on;}
						if(temp_var == 0 && you.selected == on) { play_random_snd_fx();	}
						}
					}					
				} 
   		left_pressed = 0;
			}
   	if(mouse_right) {
   		right_pressed = 1;
			}
		if(!mouse_right) {
			if(dest_set) {
				dest_Set = 0;
				}
			
			if(right_pressed && !dest_set) {
				temp.x = mouse_pos.x;
				temp.y = mouse_pos.y;
				temp.z = 2000;
				vec_for_screen(temp,camera);
				
				trace_mode = ignore_passable + ignore_Sprites + ignore_models;
				trace(camera.x,temp);
				vec_set(dest_pos,target.x);
				dest_set = 1;
				
				you = ent_create(target_dot_spr,dest_pos,target_dot);
				vec_to_angle(you.pan,normal);
				vec_Set(temp,vector(5,0,0));
				vec_rotate(temp,normal);
				vec_Add(you.x,temp);
		
				}
			
			right_pressed = 0;
			}	
   	
   	wait(1);
  		}
	}

//////////////////////////////
// End
//////////////////////////////