//////////////////////////////
// C&C Style Camera View
//////////////////////////////

//starter functions do not need to be called, they will start automatically
starter Camera_Top_Down() {
	sleep (1); // wait a second before we start
	cam_focus.x = 0;
	cam_focus.y = 0;
	cam_focus.z = -1000;
	cam_ang.pan = -90;
	cam_ang.tilt = 60;
	cam_ang.roll = 0;
	cam_dist = 800;
	cam_temp_dist = 800;
	while (1) {
		// Move the camera using the arrow keys (key_force). 
		// We multiply by 'Time' to keep it running the same speed at all frame rates
		// mouse at side of screen?
		if (mouse_pos.x > screen_size.x - 40 && camera.x < right_border ) { temp.x = 10 * time; }
		else { 
			if (mouse_pos.x < 20 && camera.x > left_border) { temp.x = -10 * time; }//left screen
			else { temp.x = 0; }//no speed
		}
		if (mouse_pos.y > screen_size.y - 40 && camera.y > bottom_border) { temp.y = -10 * time; }//back
		else {
			if (mouse_pos.y < 20 && camera.y < top_border) { temp.y = 10 * time; }
			else { temp.y = 0; }
		}
		temp.x += (key_force.x * 10) * time;	
		if (temp.x > 10 * time) {temp.x = 10 * time;} // limit max speed
		if (temp.x < -10 * time) {temp.x = -10 * time;}
		temp.y += (key_force.y * 10) * time;
		if (temp.y > 10 * time) {temp.y = 10 * time;}
		if (temp.y < -10 * time) {temp.y = -10 * time;}
		if(key_z == 1) {
			if(!z_pressed && cam_dist == zoom_distance1) { z_pressed = 1; cam_dist = zoom_distance2;}
      if(!z_pressed && cam_dist == zoom_distance2) { z_pressed = 1; cam_dist = zoom_distance3;}
      if(!z_pressed && cam_dist == zoom_distance3) { z_pressed = 1; cam_dist = zoom_distance1;}
    }  //close if block
    if(cam_temp_dist < cam_dist) { cam_temp_dist = min(cam_dist,(cam_temp_dist + 30 * time)); }
    if(cam_temp_dist > cam_dist) { cam_temp_dist = max(cam_dist,(cam_temp_dist - 30 * time)); }
		if(!key_z) { z_pressed = 0; }
		if(mouse_pos.x > screen_size.x-bmap_width(arrow)) {
			mouse_pos.x = screen_size.x-bmap_width(arrow); 
		}
    if(mouse_pos.y > screen_size.y-bmap_height(arrow)) {
      mouse_pos.y = screen_size.y-bmap_height(arrow); 
    }

		cam_focus.x += temp.x; //update the vectors when mouse moves
		cam_focus.y += temp.y;
		vec_set(camera.x,cam_temp_dist);//set the camera position
		vec_rotate(camera.x,cam_ang);//rotate the camera origin to the angles
		vec_add(camera.x,cam_focus);//add the vectors to the cameras position(moves the camera)
		vec_diff(temp,cam_focus,camera.x);//get difference from cameras position and vectors
		vec_to_angle(camera.pan,temp);//rotate the cameras pan to that direction(points the camera)
		wait (1); // wait a frame then repeat
	}
}

//////////////////////////////
// End
//////////////////////////////